/* pathentry.c generated by valac 0.43.4, the Vala compiler
 * generated from pathentry.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_PATH_ENTRY (path_entry_get_type ())
#define PATH_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_ENTRY, PathEntry))
#define PATH_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_ENTRY, PathEntryClass))
#define IS_PATH_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_ENTRY))
#define IS_PATH_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_ENTRY))
#define PATH_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_ENTRY, PathEntryClass))

typedef struct _PathEntry PathEntry;
typedef struct _PathEntryClass PathEntryClass;
typedef struct _PathEntryPrivate PathEntryPrivate;
enum  {
	PATH_ENTRY_0_PROPERTY,
	PATH_ENTRY_TEXT_PROPERTY,
	PATH_ENTRY_ENTRY_HAS_FOCUS_PROPERTY,
	PATH_ENTRY_NUM_PROPERTIES
};
static GParamSpec* path_entry_properties[PATH_ENTRY_NUM_PROPERTIES];
typedef enum  {
	PATH_ENTRY_SEARCH_MODE_UNCLEAR,
	PATH_ENTRY_SEARCH_MODE_EDIT_PATH_MOVE_END,
	PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_ALL,
	PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_LAST_WORD,
	PATH_ENTRY_SEARCH_MODE_SEARCH
} PathEntrySearchMode;

#define PATH_ENTRY_TYPE_SEARCH_MODE (path_entry_search_mode_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH,
	VIEW_TYPE_CONFIG
} ViewType;

#define TYPE_VIEW_TYPE (view_type_get_type ())
enum  {
	PATH_ENTRY_SEARCH_CHANGED_SIGNAL,
	PATH_ENTRY_SEARCH_STOPPED_SIGNAL,
	PATH_ENTRY_NUM_SIGNALS
};
static guint path_entry_signals[PATH_ENTRY_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _PathEntry {
	GtkBox parent_instance;
	PathEntryPrivate * priv;
};

struct _PathEntryClass {
	GtkBoxClass parent_class;
};

struct _PathEntryPrivate {
	GtkButton* hide_search_button;
	GtkButton* reload_search_button;
	GtkSearchEntry* search_entry;
	gchar* current_path;
	gulong can_reload_handler;
	gboolean thin_window;
	gulong search_changed_handler;
	gboolean has_error_class;
};

static gint PathEntry_private_offset;
static gpointer path_entry_parent_class = NULL;
static AdaptativeWidgetIface * path_entry_adaptative_widget_parent_iface = NULL;

GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST;
GType adaptative_widget_get_type (void) G_GNUC_CONST;
GType path_entry_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PathEntry, g_object_unref)
GType path_entry_search_mode_get_type (void) G_GNUC_CONST;
static void path_entry_real_get_preferred_width (GtkWidget* base,
                                          gint* minimum_width,
                                          gint* natural_width);
static void path_entry_real_set_window_size (AdaptativeWidget* base,
                                      AdaptativeWidgetWindowSize new_size);
gboolean adaptative_widget_window_size_is_quite_thin (AdaptativeWidgetWindowSize window_size);
static void ___lambda16_ (PathEntry* self);
static void ____lambda16__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
void path_entry_entry_grab_focus_without_selecting (PathEntry* self);
void path_entry_entry_grab_focus (PathEntry* self);
gboolean path_entry_handle_event (PathEntry* self,
                                  GdkEventKey* event);
GType view_type_get_type (void) G_GNUC_CONST;
void path_entry_set_path (PathEntry* self,
                          ViewType type,
                          const gchar* _path);
gboolean dconf_window_is_path_invalid (const gchar* path);
void path_entry_prepare (PathEntry* self,
                         PathEntrySearchMode mode,
                         const gchar* search);
static inline void _path_entry_prepare (PathEntry* self,
                          PathEntrySearchMode mode,
                          const gchar* search);
gchar* model_utils_get_parent_path (const gchar* path);
PathEntry* path_entry_new (void);
PathEntry* path_entry_construct (GType object_type);
const gchar* path_entry_get_text (PathEntry* self);
gboolean path_entry_get_entry_has_focus (PathEntry* self);
static GObject * path_entry_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _path_entry___lambda17_ (PathEntry* self);
static void __path_entry___lambda17__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                               gpointer self);
static void _path_entry___lambda18_ (PathEntry* self);
static void __path_entry___lambda18__gtk_search_entry_stop_search (GtkSearchEntry* _sender,
                                                            gpointer self);
static void path_entry_finalize (GObject * obj);
static void _vala_path_entry_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
path_entry_get_instance_private (PathEntry* self)
{
	return G_STRUCT_MEMBER_P (self, PathEntry_private_offset);
}

GType
path_entry_search_mode_get_type (void)
{
	static volatile gsize path_entry_search_mode_type_id__volatile = 0;
	if (g_once_init_enter (&path_entry_search_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{PATH_ENTRY_SEARCH_MODE_UNCLEAR, "PATH_ENTRY_SEARCH_MODE_UNCLEAR", "unclear"}, {PATH_ENTRY_SEARCH_MODE_EDIT_PATH_MOVE_END, "PATH_ENTRY_SEARCH_MODE_EDIT_PATH_MOVE_END", "edit-path-move-end"}, {PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_ALL, "PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_ALL", "edit-path-select-all"}, {PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_LAST_WORD, "PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_LAST_WORD", "edit-path-select-last-word"}, {PATH_ENTRY_SEARCH_MODE_SEARCH, "PATH_ENTRY_SEARCH_MODE_SEARCH", "search"}, {0, NULL, NULL}};
		GType path_entry_search_mode_type_id;
		path_entry_search_mode_type_id = g_enum_register_static ("PathEntrySearchMode", values);
		g_once_init_leave (&path_entry_search_mode_type_id__volatile, path_entry_search_mode_type_id);
	}
	return path_entry_search_mode_type_id__volatile;
}

static void
path_entry_real_get_preferred_width (GtkWidget* base,
                                     gint* minimum_width,
                                     gint* natural_width)
{
	PathEntry * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 33 "../editor/pathentry.vala"
	self = (PathEntry*) base;
#line 35 "../editor/pathentry.vala"
	GTK_WIDGET_CLASS (path_entry_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), &_tmp0_, &_tmp1_);
#line 35 "../editor/pathentry.vala"
	_vala_minimum_width = _tmp0_;
#line 35 "../editor/pathentry.vala"
	_vala_natural_width = _tmp1_;
#line 36 "../editor/pathentry.vala"
	_vala_minimum_width = 72;
#line 33 "../editor/pathentry.vala"
	if (minimum_width) {
#line 33 "../editor/pathentry.vala"
		*minimum_width = _vala_minimum_width;
#line 218 "pathentry.c"
	}
#line 33 "../editor/pathentry.vala"
	if (natural_width) {
#line 33 "../editor/pathentry.vala"
		*natural_width = _vala_natural_width;
#line 224 "pathentry.c"
	}
}

static void
___lambda16_ (PathEntry* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 53 "../editor/pathentry.vala"
	_tmp0_ = self->priv->reload_search_button;
#line 53 "../editor/pathentry.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 53 "../editor/pathentry.vala"
	_tmp2_ = _tmp1_;
#line 53 "../editor/pathentry.vala"
	if (_tmp2_) {
#line 242 "pathentry.c"
		GtkButton* _tmp3_;
		GtkButton* _tmp4_;
#line 55 "../editor/pathentry.vala"
		_tmp3_ = self->priv->hide_search_button;
#line 55 "../editor/pathentry.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 56 "../editor/pathentry.vala"
		_tmp4_ = self->priv->reload_search_button;
#line 56 "../editor/pathentry.vala"
		gtk_widget_show ((GtkWidget*) _tmp4_);
#line 253 "pathentry.c"
	} else {
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
#line 60 "../editor/pathentry.vala"
		_tmp5_ = self->priv->reload_search_button;
#line 60 "../editor/pathentry.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 61 "../editor/pathentry.vala"
		_tmp6_ = self->priv->hide_search_button;
#line 61 "../editor/pathentry.vala"
		gtk_widget_show ((GtkWidget*) _tmp6_);
#line 265 "pathentry.c"
	}
}

static void
____lambda16__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 52 "../editor/pathentry.vala"
	___lambda16_ ((PathEntry*) self);
#line 276 "pathentry.c"
}

static void
path_entry_real_set_window_size (AdaptativeWidget* base,
                                 AdaptativeWidgetWindowSize new_size)
{
	PathEntry * self;
	gboolean _thin_window = FALSE;
#line 41 "../editor/pathentry.vala"
	self = (PathEntry*) base;
#line 43 "../editor/pathentry.vala"
	_thin_window = adaptative_widget_window_size_is_quite_thin (new_size);
#line 44 "../editor/pathentry.vala"
	if (self->priv->thin_window == _thin_window) {
#line 45 "../editor/pathentry.vala"
		return;
#line 293 "pathentry.c"
	}
#line 46 "../editor/pathentry.vala"
	self->priv->thin_window = _thin_window;
#line 48 "../editor/pathentry.vala"
	if (_thin_window) {
#line 299 "pathentry.c"
		GtkSearchEntry* _tmp0_;
		GtkButton* _tmp1_;
		gulong _tmp2_;
		GtkButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 50 "../editor/pathentry.vala"
		_tmp0_ = self->priv->search_entry;
#line 50 "../editor/pathentry.vala"
		gtk_entry_set_icon_from_pixbuf ((GtkEntry*) _tmp0_, GTK_ENTRY_ICON_PRIMARY, NULL);
#line 52 "../editor/pathentry.vala"
		_tmp1_ = self->priv->reload_search_button;
#line 52 "../editor/pathentry.vala"
		_tmp2_ = g_signal_connect_object ((GObject*) _tmp1_, "notify::sensitive", (GCallback) ____lambda16__g_object_notify, self, 0);
#line 52 "../editor/pathentry.vala"
		self->priv->can_reload_handler = _tmp2_;
#line 65 "../editor/pathentry.vala"
		_tmp3_ = self->priv->reload_search_button;
#line 65 "../editor/pathentry.vala"
		_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
#line 65 "../editor/pathentry.vala"
		_tmp5_ = _tmp4_;
#line 65 "../editor/pathentry.vala"
		if (!_tmp5_) {
#line 324 "pathentry.c"
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
#line 67 "../editor/pathentry.vala"
			_tmp6_ = self->priv->reload_search_button;
#line 67 "../editor/pathentry.vala"
			gtk_widget_hide ((GtkWidget*) _tmp6_);
#line 68 "../editor/pathentry.vala"
			_tmp7_ = self->priv->hide_search_button;
#line 68 "../editor/pathentry.vala"
			gtk_widget_show ((GtkWidget*) _tmp7_);
#line 335 "pathentry.c"
		}
	} else {
		GtkSearchEntry* _tmp8_;
		GtkButton* _tmp9_;
		GtkButton* _tmp10_;
		GtkButton* _tmp11_;
#line 73 "../editor/pathentry.vala"
		_tmp8_ = self->priv->search_entry;
#line 73 "../editor/pathentry.vala"
		gtk_entry_set_icon_from_icon_name ((GtkEntry*) _tmp8_, GTK_ENTRY_ICON_PRIMARY, "edit-find-symbolic");
#line 75 "../editor/pathentry.vala"
		_tmp9_ = self->priv->reload_search_button;
#line 75 "../editor/pathentry.vala"
		g_signal_handler_disconnect ((GObject*) _tmp9_, self->priv->can_reload_handler);
#line 77 "../editor/pathentry.vala"
		_tmp10_ = self->priv->hide_search_button;
#line 77 "../editor/pathentry.vala"
		gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 78 "../editor/pathentry.vala"
		_tmp11_ = self->priv->reload_search_button;
#line 78 "../editor/pathentry.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 358 "pathentry.c"
	}
}

void
path_entry_entry_grab_focus_without_selecting (PathEntry* self)
{
	GtkSearchEntry* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	GtkSearchEntry* _tmp11_;
#line 100 "../editor/pathentry.vala"
	g_return_if_fail (self != NULL);
#line 102 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 102 "../editor/pathentry.vala"
	_tmp1_ = gtk_entry_get_text_length ((GtkEntry*) _tmp0_);
#line 102 "../editor/pathentry.vala"
	_tmp2_ = _tmp1_;
#line 102 "../editor/pathentry.vala"
	if (_tmp2_ != ((guint) 0)) {
#line 379 "pathentry.c"
		GtkSearchEntry* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		GtkSearchEntry* _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		GtkSearchEntry* _tmp10_;
#line 104 "../editor/pathentry.vala"
		_tmp3_ = self->priv->search_entry;
#line 104 "../editor/pathentry.vala"
		g_object_get ((GtkEntry*) _tmp3_, "cursor-position", &_tmp4_, NULL);
#line 104 "../editor/pathentry.vala"
		_tmp5_ = _tmp4_;
#line 104 "../editor/pathentry.vala"
		_tmp6_ = self->priv->search_entry;
#line 104 "../editor/pathentry.vala"
		_tmp7_ = gtk_entry_get_text_length ((GtkEntry*) _tmp6_);
#line 104 "../editor/pathentry.vala"
		_tmp8_ = _tmp7_;
#line 104 "../editor/pathentry.vala"
		if (((guint) _tmp5_) == _tmp8_) {
#line 401 "pathentry.c"
			GtkSearchEntry* _tmp9_;
#line 105 "../editor/pathentry.vala"
			_tmp9_ = self->priv->search_entry;
#line 105 "../editor/pathentry.vala"
			g_signal_emit_by_name ((GtkEntry*) _tmp9_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINE_ENDS, -1, FALSE);
#line 407 "pathentry.c"
		}
#line 106 "../editor/pathentry.vala"
		_tmp10_ = self->priv->search_entry;
#line 106 "../editor/pathentry.vala"
		g_signal_emit_by_name ((GtkEntry*) _tmp10_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINE_ENDS, 1, FALSE);
#line 413 "pathentry.c"
	}
#line 108 "../editor/pathentry.vala"
	_tmp11_ = self->priv->search_entry;
#line 108 "../editor/pathentry.vala"
	gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp11_);
#line 419 "pathentry.c"
}

void
path_entry_entry_grab_focus (PathEntry* self)
{
	GtkSearchEntry* _tmp0_;
#line 110 "../editor/pathentry.vala"
	g_return_if_fail (self != NULL);
#line 112 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 112 "../editor/pathentry.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 432 "pathentry.c"
}

gboolean
path_entry_handle_event (PathEntry* self,
                         GdkEventKey* event)
{
	gboolean result = FALSE;
	GtkSearchEntry* _tmp0_;
#line 114 "../editor/pathentry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "../editor/pathentry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 116 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 116 "../editor/pathentry.vala"
	result = gtk_search_entry_handle_event (_tmp0_, (GdkEvent*) event);
#line 116 "../editor/pathentry.vala"
	return result;
#line 451 "pathentry.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 475 "pathentry.c"
}

void
path_entry_set_path (PathEntry* self,
                     ViewType type,
                     const gchar* _path)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 120 "../editor/pathentry.vala"
	g_return_if_fail (self != NULL);
#line 120 "../editor/pathentry.vala"
	g_return_if_fail (_path != NULL);
#line 122 "../editor/pathentry.vala"
	_tmp0_ = string_strip (_path);
#line 122 "../editor/pathentry.vala"
	path = _tmp0_;
#line 124 "../editor/pathentry.vala"
	if (!self->priv->has_error_class) {
#line 498 "pathentry.c"
		const gchar* _tmp2_;
#line 124 "../editor/pathentry.vala"
		_tmp2_ = path;
#line 124 "../editor/pathentry.vala"
		_tmp1_ = dconf_window_is_path_invalid (_tmp2_);
#line 504 "pathentry.c"
	} else {
#line 124 "../editor/pathentry.vala"
		_tmp1_ = FALSE;
#line 508 "pathentry.c"
	}
#line 124 "../editor/pathentry.vala"
	if (_tmp1_) {
#line 512 "pathentry.c"
		GtkSearchEntry* _tmp3_;
		GtkStyleContext* _tmp4_;
#line 126 "../editor/pathentry.vala"
		self->priv->has_error_class = TRUE;
#line 127 "../editor/pathentry.vala"
		_tmp3_ = self->priv->search_entry;
#line 127 "../editor/pathentry.vala"
		_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 127 "../editor/pathentry.vala"
		gtk_style_context_add_class (_tmp4_, "error");
#line 523 "pathentry.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 129 "../editor/pathentry.vala"
		if (self->priv->has_error_class) {
#line 528 "pathentry.c"
			const gchar* _tmp6_;
#line 129 "../editor/pathentry.vala"
			_tmp6_ = path;
#line 129 "../editor/pathentry.vala"
			_tmp5_ = !dconf_window_is_path_invalid (_tmp6_);
#line 534 "pathentry.c"
		} else {
#line 129 "../editor/pathentry.vala"
			_tmp5_ = FALSE;
#line 538 "pathentry.c"
		}
#line 129 "../editor/pathentry.vala"
		if (_tmp5_) {
#line 542 "pathentry.c"
			GtkSearchEntry* _tmp7_;
			GtkStyleContext* _tmp8_;
#line 131 "../editor/pathentry.vala"
			self->priv->has_error_class = FALSE;
#line 132 "../editor/pathentry.vala"
			_tmp7_ = self->priv->search_entry;
#line 132 "../editor/pathentry.vala"
			_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 132 "../editor/pathentry.vala"
			gtk_style_context_remove_class (_tmp8_, "error");
#line 553 "pathentry.c"
		}
	}
#line 135 "../editor/pathentry.vala"
	_tmp9_ = path;
#line 135 "../editor/pathentry.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 135 "../editor/pathentry.vala"
	_g_free0 (self->priv->current_path);
#line 135 "../editor/pathentry.vala"
	self->priv->current_path = _tmp10_;
#line 120 "../editor/pathentry.vala"
	_g_free0 (path);
#line 566 "pathentry.c"
}

void
path_entry_prepare (PathEntry* self,
                    PathEntrySearchMode mode,
                    const gchar* search)
{
	GtkSearchEntry* _tmp0_;
	GtkSearchEntry* _tmp1_;
#line 139 "../editor/pathentry.vala"
	g_return_if_fail (self != NULL);
#line 139 "../editor/pathentry.vala"
	_vala_return_if_fail (self->priv->search_changed_handler != ((gulong) 0), "search_changed_handler != 0");
#line 142 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 142 "../editor/pathentry.vala"
	g_signal_handler_block (_tmp0_, self->priv->search_changed_handler);
#line 143 "../editor/pathentry.vala"
	_path_entry_prepare (self, mode, search);
#line 144 "../editor/pathentry.vala"
	_tmp1_ = self->priv->search_entry;
#line 144 "../editor/pathentry.vala"
	g_signal_handler_unblock (_tmp1_, self->priv->search_changed_handler);
#line 590 "pathentry.c"
}

static inline void
_path_entry_prepare (PathEntry* self,
                     PathEntrySearchMode mode,
                     const gchar* search)
{
#line 146 "../editor/pathentry.vala"
	g_return_if_fail (self != NULL);
#line 148 "../editor/pathentry.vala"
	switch (mode) {
#line 148 "../editor/pathentry.vala"
		case PATH_ENTRY_SEARCH_MODE_EDIT_PATH_MOVE_END:
#line 604 "pathentry.c"
		{
			const gchar* _tmp0_ = NULL;
			GtkSearchEntry* _tmp2_;
#line 151 "../editor/pathentry.vala"
			if (search == NULL) {
#line 610 "pathentry.c"
				const gchar* _tmp1_;
#line 151 "../editor/pathentry.vala"
				_tmp1_ = self->priv->current_path;
#line 151 "../editor/pathentry.vala"
				_tmp0_ = _tmp1_;
#line 616 "pathentry.c"
			} else {
#line 151 "../editor/pathentry.vala"
				_tmp0_ = (const gchar*) search;
#line 620 "pathentry.c"
			}
#line 151 "../editor/pathentry.vala"
			_tmp2_ = self->priv->search_entry;
#line 151 "../editor/pathentry.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp2_, _tmp0_);
#line 152 "../editor/pathentry.vala"
			path_entry_entry_grab_focus_without_selecting (self);
#line 153 "../editor/pathentry.vala"
			return;
#line 630 "pathentry.c"
		}
#line 148 "../editor/pathentry.vala"
		case PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_ALL:
#line 634 "pathentry.c"
		{
			const gchar* _tmp3_ = NULL;
			GtkSearchEntry* _tmp5_;
			GtkSearchEntry* _tmp6_;
#line 156 "../editor/pathentry.vala"
			if (search == NULL) {
#line 641 "pathentry.c"
				const gchar* _tmp4_;
#line 156 "../editor/pathentry.vala"
				_tmp4_ = self->priv->current_path;
#line 156 "../editor/pathentry.vala"
				_tmp3_ = _tmp4_;
#line 647 "pathentry.c"
			} else {
#line 156 "../editor/pathentry.vala"
				_tmp3_ = (const gchar*) search;
#line 651 "pathentry.c"
			}
#line 156 "../editor/pathentry.vala"
			_tmp5_ = self->priv->search_entry;
#line 156 "../editor/pathentry.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp5_, _tmp3_);
#line 157 "../editor/pathentry.vala"
			_tmp6_ = self->priv->search_entry;
#line 157 "../editor/pathentry.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 158 "../editor/pathentry.vala"
			return;
#line 663 "pathentry.c"
		}
#line 148 "../editor/pathentry.vala"
		case PATH_ENTRY_SEARCH_MODE_EDIT_PATH_SELECT_LAST_WORD:
#line 667 "pathentry.c"
		{
			GtkSearchEntry* _tmp7_;
			GtkSearchEntry* _tmp8_;
			const gchar* _tmp9_;
			GtkSearchEntry* _tmp10_;
			guint _tmp11_;
			guint _tmp12_;
			GtkSearchEntry* _tmp14_;
			guint _tmp15_;
			guint _tmp16_;
			GtkSearchEntry* _tmp31_;
#line 161 "../editor/pathentry.vala"
			_tmp7_ = self->priv->search_entry;
#line 161 "../editor/pathentry.vala"
			g_signal_emit_by_name ((GtkEntry*) _tmp7_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINE_ENDS, -1, FALSE);
#line 162 "../editor/pathentry.vala"
			_tmp8_ = self->priv->search_entry;
#line 162 "../editor/pathentry.vala"
			_tmp9_ = self->priv->current_path;
#line 162 "../editor/pathentry.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp8_, _tmp9_);
#line 163 "../editor/pathentry.vala"
			_tmp10_ = self->priv->search_entry;
#line 163 "../editor/pathentry.vala"
			_tmp11_ = gtk_entry_get_text_length ((GtkEntry*) _tmp10_);
#line 163 "../editor/pathentry.vala"
			_tmp12_ = _tmp11_;
#line 163 "../editor/pathentry.vala"
			if (_tmp12_ == ((guint) 1)) {
#line 697 "pathentry.c"
				GtkSearchEntry* _tmp13_;
#line 165 "../editor/pathentry.vala"
				_tmp13_ = self->priv->search_entry;
#line 165 "../editor/pathentry.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 166 "../editor/pathentry.vala"
				return;
#line 705 "pathentry.c"
			}
#line 168 "../editor/pathentry.vala"
			_tmp14_ = self->priv->search_entry;
#line 168 "../editor/pathentry.vala"
			_tmp15_ = gtk_entry_get_text_length ((GtkEntry*) _tmp14_);
#line 168 "../editor/pathentry.vala"
			_tmp16_ = _tmp15_;
#line 168 "../editor/pathentry.vala"
			if (_tmp16_ != ((guint) 0)) {
#line 715 "pathentry.c"
				GtkSearchEntry* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				GtkSearchEntry* _tmp20_;
				guint _tmp21_;
				guint _tmp22_;
				GtkSearchEntry* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				GtkSearchEntry* _tmp30_;
#line 170 "../editor/pathentry.vala"
				_tmp17_ = self->priv->search_entry;
#line 170 "../editor/pathentry.vala"
				g_object_get ((GtkEntry*) _tmp17_, "cursor-position", &_tmp18_, NULL);
#line 170 "../editor/pathentry.vala"
				_tmp19_ = _tmp18_;
#line 170 "../editor/pathentry.vala"
				_tmp20_ = self->priv->search_entry;
#line 170 "../editor/pathentry.vala"
				_tmp21_ = gtk_entry_get_text_length ((GtkEntry*) _tmp20_);
#line 170 "../editor/pathentry.vala"
				_tmp22_ = _tmp21_;
#line 170 "../editor/pathentry.vala"
				if (((guint) _tmp19_) == _tmp22_) {
#line 743 "pathentry.c"
					GtkSearchEntry* _tmp23_;
#line 171 "../editor/pathentry.vala"
					_tmp23_ = self->priv->search_entry;
#line 171 "../editor/pathentry.vala"
					g_signal_emit_by_name ((GtkEntry*) _tmp23_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINE_ENDS, -1, FALSE);
#line 749 "pathentry.c"
				}
#line 172 "../editor/pathentry.vala"
				_tmp24_ = self->priv->search_entry;
#line 172 "../editor/pathentry.vala"
				_tmp25_ = self->priv->current_path;
#line 172 "../editor/pathentry.vala"
				_tmp26_ = model_utils_get_parent_path (_tmp25_);
#line 172 "../editor/pathentry.vala"
				_tmp27_ = _tmp26_;
#line 172 "../editor/pathentry.vala"
				_tmp28_ = strlen (_tmp27_);
#line 172 "../editor/pathentry.vala"
				_tmp29_ = _tmp28_;
#line 172 "../editor/pathentry.vala"
				g_signal_emit_by_name ((GtkEntry*) _tmp24_, "move-cursor", GTK_MOVEMENT_VISUAL_POSITIONS, _tmp29_, FALSE);
#line 172 "../editor/pathentry.vala"
				_g_free0 (_tmp27_);
#line 173 "../editor/pathentry.vala"
				_tmp30_ = self->priv->search_entry;
#line 173 "../editor/pathentry.vala"
				g_signal_emit_by_name ((GtkEntry*) _tmp30_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINE_ENDS, 1, TRUE);
#line 771 "pathentry.c"
			}
#line 175 "../editor/pathentry.vala"
			_tmp31_ = self->priv->search_entry;
#line 175 "../editor/pathentry.vala"
			gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp31_);
#line 176 "../editor/pathentry.vala"
			return;
#line 779 "pathentry.c"
		}
#line 148 "../editor/pathentry.vala"
		case PATH_ENTRY_SEARCH_MODE_SEARCH:
#line 783 "pathentry.c"
		{
			GtkSearchEntry* _tmp32_;
			GtkSearchEntry* _tmp33_;
#line 179 "../editor/pathentry.vala"
			_tmp32_ = self->priv->search_entry;
#line 179 "../editor/pathentry.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp32_, "");
#line 180 "../editor/pathentry.vala"
			_tmp33_ = self->priv->search_entry;
#line 180 "../editor/pathentry.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp33_);
#line 181 "../editor/pathentry.vala"
			return;
#line 797 "pathentry.c"
		}
		default:
#line 148 "../editor/pathentry.vala"
		case PATH_ENTRY_SEARCH_MODE_UNCLEAR:
#line 802 "pathentry.c"
		{
#line 185 "../editor/pathentry.vala"
			g_assert_not_reached ();
#line 806 "pathentry.c"
		}
	}
}

PathEntry*
path_entry_construct (GType object_type)
{
	PathEntry * self = NULL;
#line 21 "../editor/pathentry.vala"
	self = (PathEntry*) g_object_new (object_type, NULL);
#line 21 "../editor/pathentry.vala"
	return self;
#line 819 "pathentry.c"
}

PathEntry*
path_entry_new (void)
{
#line 21 "../editor/pathentry.vala"
	return path_entry_construct (TYPE_PATH_ENTRY);
#line 827 "pathentry.c"
}

const gchar*
path_entry_get_text (PathEntry* self)
{
	const gchar* result;
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 30 "../editor/pathentry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 30 "../editor/pathentry.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 30 "../editor/pathentry.vala"
	_tmp2_ = _tmp1_;
#line 30 "../editor/pathentry.vala"
	result = _tmp2_;
#line 30 "../editor/pathentry.vala"
	return result;
#line 849 "pathentry.c"
}

gboolean
path_entry_get_entry_has_focus (PathEntry* self)
{
	gboolean result;
	GtkSearchEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 31 "../editor/pathentry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 31 "../editor/pathentry.vala"
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
#line 31 "../editor/pathentry.vala"
	_tmp2_ = _tmp1_;
#line 31 "../editor/pathentry.vala"
	result = _tmp2_;
#line 31 "../editor/pathentry.vala"
	return result;
#line 871 "pathentry.c"
}

static void
_path_entry___lambda17_ (PathEntry* self)
{
#line 96 "../editor/pathentry.vala"
	g_signal_emit (self, path_entry_signals[PATH_ENTRY_SEARCH_CHANGED_SIGNAL], 0);
#line 879 "pathentry.c"
}

static void
__path_entry___lambda17__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                          gpointer self)
{
#line 96 "../editor/pathentry.vala"
	_path_entry___lambda17_ ((PathEntry*) self);
#line 888 "pathentry.c"
}

static void
_path_entry___lambda18_ (PathEntry* self)
{
#line 97 "../editor/pathentry.vala"
	g_signal_emit (self, path_entry_signals[PATH_ENTRY_SEARCH_STOPPED_SIGNAL], 0);
#line 896 "pathentry.c"
}

static void
__path_entry___lambda18__gtk_search_entry_stop_search (GtkSearchEntry* _sender,
                                                       gpointer self)
{
#line 97 "../editor/pathentry.vala"
	_path_entry___lambda18_ ((PathEntry*) self);
#line 905 "pathentry.c"
}

static GObject *
path_entry_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathEntry * self;
	GtkSearchEntry* _tmp0_;
	gulong _tmp1_;
	GtkSearchEntry* _tmp2_;
#line 94 "../editor/pathentry.vala"
	parent_class = G_OBJECT_CLASS (path_entry_parent_class);
#line 94 "../editor/pathentry.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 94 "../editor/pathentry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_ENTRY, PathEntry);
#line 96 "../editor/pathentry.vala"
	_tmp0_ = self->priv->search_entry;
#line 96 "../editor/pathentry.vala"
	_tmp1_ = g_signal_connect_object (_tmp0_, "search-changed", (GCallback) __path_entry___lambda17__gtk_search_entry_search_changed, self, 0);
#line 96 "../editor/pathentry.vala"
	self->priv->search_changed_handler = _tmp1_;
#line 97 "../editor/pathentry.vala"
	_tmp2_ = self->priv->search_entry;
#line 97 "../editor/pathentry.vala"
	g_signal_connect_object (_tmp2_, "stop-search", (GCallback) __path_entry___lambda18__gtk_search_entry_stop_search, self, 0);
#line 94 "../editor/pathentry.vala"
	return obj;
#line 937 "pathentry.c"
}

static void
path_entry_class_init (PathEntryClass * klass,
                       gpointer klass_data)
{
#line 21 "../editor/pathentry.vala"
	path_entry_parent_class = g_type_class_peek_parent (klass);
#line 21 "../editor/pathentry.vala"
	g_type_class_adjust_private_offset (klass, &PathEntry_private_offset);
#line 21 "../editor/pathentry.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) path_entry_real_get_preferred_width;
#line 21 "../editor/pathentry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_path_entry_get_property;
#line 21 "../editor/pathentry.vala"
	G_OBJECT_CLASS (klass)->constructor = path_entry_constructor;
#line 21 "../editor/pathentry.vala"
	G_OBJECT_CLASS (klass)->finalize = path_entry_finalize;
#line 21 "../editor/pathentry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_ENTRY_TEXT_PROPERTY, path_entry_properties[PATH_ENTRY_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../editor/pathentry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_ENTRY_ENTRY_HAS_FOCUS_PROPERTY, path_entry_properties[PATH_ENTRY_ENTRY_HAS_FOCUS_PROPERTY] = g_param_spec_boolean ("entry-has-focus", "entry-has-focus", "entry-has-focus", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../editor/pathentry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathentry.ui");
#line 21 "../editor/pathentry.vala"
	path_entry_signals[PATH_ENTRY_SEARCH_CHANGED_SIGNAL] = g_signal_new ("search-changed", TYPE_PATH_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../editor/pathentry.vala"
	path_entry_signals[PATH_ENTRY_SEARCH_STOPPED_SIGNAL] = g_signal_new ("search-stopped", TYPE_PATH_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../editor/pathentry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hide_search_button", FALSE, PathEntry_private_offset + G_STRUCT_OFFSET (PathEntryPrivate, hide_search_button));
#line 21 "../editor/pathentry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "reload_search_button", FALSE, PathEntry_private_offset + G_STRUCT_OFFSET (PathEntryPrivate, reload_search_button));
#line 21 "../editor/pathentry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_entry", FALSE, PathEntry_private_offset + G_STRUCT_OFFSET (PathEntryPrivate, search_entry));
#line 972 "pathentry.c"
}

static void
path_entry_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                             gpointer iface_data)
{
#line 21 "../editor/pathentry.vala"
	path_entry_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "../editor/pathentry.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) path_entry_real_set_window_size;
#line 983 "pathentry.c"
}

static void
path_entry_instance_init (PathEntry * self,
                          gpointer klass)
{
	gchar* _tmp0_;
#line 21 "../editor/pathentry.vala"
	self->priv = path_entry_get_instance_private (self);
#line 28 "../editor/pathentry.vala"
	_tmp0_ = g_strdup ("");
#line 28 "../editor/pathentry.vala"
	self->priv->current_path = _tmp0_;
#line 39 "../editor/pathentry.vala"
	self->priv->can_reload_handler = (gulong) 0;
#line 40 "../editor/pathentry.vala"
	self->priv->thin_window = FALSE;
#line 90 "../editor/pathentry.vala"
	self->priv->search_changed_handler = (gulong) 0;
#line 119 "../editor/pathentry.vala"
	self->priv->has_error_class = FALSE;
#line 21 "../editor/pathentry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1007 "pathentry.c"
}

static void
path_entry_finalize (GObject * obj)
{
	PathEntry * self;
#line 21 "../editor/pathentry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_ENTRY, PathEntry);
#line 23 "../editor/pathentry.vala"
	_g_object_unref0 (self->priv->hide_search_button);
#line 24 "../editor/pathentry.vala"
	_g_object_unref0 (self->priv->reload_search_button);
#line 26 "../editor/pathentry.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 28 "../editor/pathentry.vala"
	_g_free0 (self->priv->current_path);
#line 21 "../editor/pathentry.vala"
	G_OBJECT_CLASS (path_entry_parent_class)->finalize (obj);
#line 1026 "pathentry.c"
}

GType
path_entry_get_type (void)
{
	static volatile gsize path_entry_type_id__volatile = 0;
	if (g_once_init_enter (&path_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathEntry), 0, (GInstanceInitFunc) path_entry_instance_init, NULL };
		static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) path_entry_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType path_entry_type_id;
		path_entry_type_id = g_type_register_static (gtk_box_get_type (), "PathEntry", &g_define_type_info, 0);
		g_type_add_interface_static (path_entry_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
		PathEntry_private_offset = g_type_add_instance_private (path_entry_type_id, sizeof (PathEntryPrivate));
		g_once_init_leave (&path_entry_type_id__volatile, path_entry_type_id);
	}
	return path_entry_type_id__volatile;
}

static void
_vala_path_entry_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	PathEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_ENTRY, PathEntry);
#line 21 "../editor/pathentry.vala"
	switch (property_id) {
#line 21 "../editor/pathentry.vala"
		case PATH_ENTRY_TEXT_PROPERTY:
#line 21 "../editor/pathentry.vala"
		g_value_set_string (value, path_entry_get_text (self));
#line 21 "../editor/pathentry.vala"
		break;
#line 21 "../editor/pathentry.vala"
		case PATH_ENTRY_ENTRY_HAS_FOCUS_PROPERTY:
#line 21 "../editor/pathentry.vala"
		g_value_set_boolean (value, path_entry_get_entry_has_focus (self));
#line 21 "../editor/pathentry.vala"
		break;
#line 1067 "pathentry.c"
		default:
#line 21 "../editor/pathentry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/pathentry.vala"
		break;
#line 1073 "pathentry.c"
	}
}

